event = require('event')
component = require('component')

moneyTable = {
  {value=1,name='copper',index=64},
  {value=64,name='silver',index=66},
  {value=4096,name='gold',index=1},
  {value=262144,name='platinum',index=70}
}

table.sort(moneyTable,function(a,b) return a.value > b.value end)

function getCoins()
  local tab = {amount={},container={}}
  local index = 0
  for stack in component.transposer.getAllStacks(3) do
     index = index + 1
     if stack.name == 'thermalfoundation:coin' then
       tab.container[index] = {damage=stack.damage,size=stack.size}
       tab.amount[stack.damage] = (tab.amount[stack.damage] or 0) + stack.size
     end
  end
  return tab
end

function loop()
  local checkIndex = 0
  for stack in component.transposer.getAllStacks(1) do
    checkIndex = checkIndex + 1
    if stack.name == 'minecraft:paper'and stack.label and string.find(stack.label,'^%a+%s+[Cc][Hh][Ee][Cc][Kk]%s+%d+$') then
      local moneyMult = string.lower(string.match(stack.label,'^%a+'))
      for i=1,#moneyTable do
        if moneyTable[i].name == moneyMult then
          moneyMult = moneyTable[i].value
          break
        end
      end
      if type(moneyMult) == 'number' then
        for i=1,stack.size do
          local coins = getCoins()
          local money = string.match(stack.label,'%d+$') * moneyMult
          local slots = 0
          local give = {}
          for i=1,#moneyTable do
            if money >= moneyTable[i].value then
              give[moneyTable[i].index] = math.min(math.floor(money/moneyTable[i].value),coins.amount[moneyTable[i].index])
              slots = slots + math.ceil(give[moneyTable[i].index]/64)
              money = money - moneyTable[i].value * give[moneyTable[i].index]
            end
          end
          if money == 0 then
            local freeslots = {}
            local index = 0
            for stack2 in component.transposer.getAllStacks(1) do
              index = index + 1
              if not stack2.name then
                table.insert(freeslots,index)
              end
            end
            if #freeslots >= slots then
              local trashSlot
              local trashIndex = 0
              for trashStack in component.transposer.getAllStacks(2) do
                trashIndex = trashIndex + 1
                if trashStack.name == nil then
                  trashSlot = trashIndex
                  break
                end
              end
              if trashSlot then
                component.transposer.transferItem(1,2,1,checkIndex,trashSlot)
                local offset = 1
                for key,value in pairs(give) do
                  local reqslots = math.ceil(value/64)
                  for i=offset,offset+reqslots-1 do
                    i=freeslots[i]
                    local inSlot = 0
                    while inSlot < math.min(value,64) do
                      local aIndex = 0
                      for inStack in component.transposer.getAllStacks(3) do
                        aIndex = aIndex + 1
                        if inStack.name == 'thermalfoundation:coin' and inStack.damage == key then
                          component.transposer.transferItem(3,1,math.min((math.min(value,64)-inSlot),inStack.size),aIndex,i)
                          inSlot = inSlot + inStack.size
                        end
                      end
                    end
                    value = value - 64
                  end
                  offset = offset+reqslots
                end
              end
            end
          else
            break
          end
        end
      end
    end
  end
end

function start()
  timer = event.timer(1,loop,math.huge)
end

loop()